package com.gh4a.adapter;

import org.eclipse.egit.github.core.Download;

import android.content.Context;
import android.support.v7.widget.RecyclerView;
import android.text.format.Formatter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.gh4a.R;
import com.gh4a.utils.StringUtils;

public class DownloadAdapter extends RootAdapter<Download, DownloadAdapter.ViewHolder> {
    public DownloadAdapter(Context context) {
        super(context);
    }

    @Override
    public ViewHolder onCreateViewHolder(LayoutInflater inflater, ViewGroup parent) {
        View v = inflater.inflate(R.layout.row_download, parent, false);
        return new ViewHolder(v);
    }

    @Override
    public void onBindViewHolder(ViewHolder holder, Download download) {
        holder.tvTitle.setText(download.getName());
        if (!StringUtils.isBlank(download.getDescription())) {
            holder.tvDesc.setVisibility(View.VISIBLE);
            holder.tvDesc.setText(download.getDescription());
        } else {
            holder.tvDesc.setVisibility(View.GONE);
        }

        holder.tvCreatedAt.setText(mContext.getString(R.string.download_created,
                StringUtils.formatRelativeTime(mContext, download.getCreatedAt(), true)));
        holder.tvSize.setText(Formatter.formatFileSize(mContext, download.getSize()));
        holder.tvDownloads.setText(String.valueOf(download.getDownloadCount()));
    }

    public static class ViewHolder extends RecyclerView.ViewHolder {
        private ViewHolder(View view) {
            super(view);
            tvTitle = (TextView) view.findViewById(R.id.tv_title);
            tvDesc = (TextView) view.findViewById(R.id.tv_desc);
            tvCreatedAt = (TextView) view.findViewById(R.id.tv_created_at);
            tvSize = (TextView) view.findViewById(R.id.tv_size);
            tvDownloads = (TextView) view.findViewById(R.id.tv_downloads);
        }

        private TextView tvTitle;
        private TextView tvDesc;
        private TextView tvSize;
        private TextView tvDownloads;
        private TextView tvCreatedAt;
    }
}
